//+------------------------------------------------------------------+
//|                                            ema channel cross.mq4 |
//|                                                           brax64 |
//|                                         http://www.forex-tsd.com |
//+------------------------------------------------------------------+

#property copyright "brax64"
#property link      "http://www.forex-tsd.com"

#property indicator_chart_window

extern int    EMA_length       = 34;
extern color  arrowsUpColor    = Lime;
extern color  arrowsDnColor    = Red;
extern bool   alertsOn         = true;
extern bool   alertsOnCurrent  = false;
extern bool   alertsMessage    = true;
extern bool   alertsSound      = false;
extern bool   alertsEmail      = false;


double buy[], sell[], ema_high[], ema_low[], trend[];
string emachobj = "emachobj";

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   IndicatorBuffers(5);
   SetIndexBuffer(0, ema_high);
   SetIndexBuffer(1, ema_low);
   SetIndexBuffer(2, buy);
   SetIndexBuffer(3, sell);
   SetIndexBuffer(4, trend);
   
   for(int i = 0; i < 5; i++)
   {
      SetIndexStyle(i, DRAW_NONE);
      SetIndexLabel(i, NULL);
   }
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+

int deinit()
{
   string lookFor       = emachobj+":";
   int    lookForLength = StringLen(lookFor);
   for(int i = ObjectsTotal() - 1; i >= 0; i--)
   {
      string objectName = ObjectName(i);
         if(StringSubstr(objectName, 0, lookForLength) == lookFor) ObjectDelete(objectName);
   }
   return(0);
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+

int start()
{
   int limit;  
   int counted_bars = IndicatorCounted(); 
   if(counted_bars < 0) return(-1);
   if(counted_bars > 0) counted_bars--;
   limit = Bars-counted_bars;

   for(int k = limit; k >= 0; k--)
   {
      ema_high[k] = iMA(NULL, 0, EMA_length, 0, MODE_EMA, PRICE_HIGH, k);
      ema_low[k]  = iMA(NULL, 0, EMA_length, 0, MODE_EMA, PRICE_LOW,  k);
      buy[k]      = 0;
      sell[k]     = 0;
      
      if(Close[k] > ema_high[k] && Low[k] > ema_high[k])    buy[k]  = Low[k];
      
      if(Close[k] < ema_low[k]  && High[k] < ema_low[k])    sell[k] = High[k];
      
      trend[k] = trend[k + 1];
      if(buy[k]  != 0) trend[k] =  1;
      if(sell[k] != 0) trend[k] = -1;
      manageArrow(k);
   }
   
   if(alertsOn)
   {
      if(alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      if(trend[whichBar] != trend[whichBar + 1])
         if(trend[whichBar] == 1)
               doAlert("above");
         else  doAlert("below");
   }
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

void doAlert(string doWhat)
{
   static string   previousAlert = "nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0])
      {
          previousAlert  = doWhat;
          previousTime   = Time[0];
          message =  StringConcatenate(Symbol(), "-", Period(), " at ", TimeToStr(TimeLocal(), TIME_SECONDS), " EMA CHANNEL: valid cross ", doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol(), "Ema Channel "), message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

void manageArrow(int k)
{
   deleteArrow(Time[k]);
   if (trend[k] != trend[k + 1])
   {
      if (trend[k] ==  1) drawArrow(k, arrowsUpColor, 241);
      if (trend[k] == -1) drawArrow(k, arrowsDnColor, 242);
   }
}               

void drawArrow(int k, color theColor, int theCode)
{
   string name = emachobj + ":" + Time[k];
   double gap  = 3 * iATR(NULL, 0, 20, k) / 4;   
      
   ObjectCreate(name, OBJ_ARROW, 0, Time[k], 0);
      ObjectSet(name, OBJPROP_ARROWCODE, theCode);
      ObjectSet(name, OBJPROP_COLOR, theColor);
      if (trend[k] ==  1)
            ObjectSet(name, OBJPROP_PRICE1, Low[k] - gap);
      else  ObjectSet(name, OBJPROP_PRICE1, High[k] + gap);
}

void deleteArrow(datetime time)
{
   string lookFor = emachobj + ":" + time;
   ObjectDelete(lookFor);
}



